// Generated by CoffeeScript 1.10.0
(function() {
  module.exports = {
    body: function(pattern, housing) {
      var bodyLength, bodyWidth, firstPad, lastPad, lineWidth, ref, settings, x, y;
      settings = pattern.settings;
      lineWidth = settings.lineWidth.silkscreen;
      bodyWidth = housing.bodyWidth.nom;
      bodyLength = housing.bodyLength.nom;
      ref = pattern.extremePads(), firstPad = ref[0], lastPad = ref[1];
      x = bodyWidth / 2 + lineWidth / 2;
      y = bodyLength / 2 + lineWidth / 2;
      return this.preamble(pattern, housing).rectangle(-x, -y, x, y);
    },
    connector: function(pattern, housing) {
      var bodyLength, bodyWidth, firstPad, lastPad, lineWidth, ref, settings, x, y;
      settings = pattern.settings;
      lineWidth = settings.lineWidth.silkscreen;
      bodyWidth = housing.bodyWidth.nom;
      bodyLength = housing.bodyLength.nom;
      ref = pattern.extremePads(), firstPad = ref[0], lastPad = ref[1];
      x = bodyWidth / 2 + lineWidth / 2;
      y = bodyLength / 2 + lineWidth / 2;
      return this.preamble(pattern, housing).rectangle(-x, -y, x, y).polarityMark(-x - lineWidth, firstPad.y);
    },
    dual: function(pattern, housing) {
      var bodyLength, bodyWidth, cp, gap, lineWidth, settings, x1, x2, x3, xp, yl1, yl2, yl3, yl4, yl5, yp, yr1, yr2, yr3, yr4;
      settings = pattern.settings;
      lineWidth = settings.lineWidth.silkscreen;
      bodyWidth = housing.bodyWidth.nom;
      bodyLength = housing.bodyLength.nom;
      cp = pattern.cornerPads();
      gap = lineWidth / 2 + settings.clearance.padToSilk;
      x1 = cp.topLeft.x - cp.topLeft.width / 2 - gap;
      x2 = -bodyWidth / 2 - lineWidth / 2;
      if (x1 > x2) {
        x1 = x2;
      }
      x3 = bodyWidth / 2 + lineWidth / 2;
      yl1 = -bodyLength / 2 - lineWidth / 2;
      yl2 = cp.topLeft.y - cp.topLeft.height / 2 - gap;
      if (yl1 > yl2) {
        yl1 = yl2;
      }
      yl3 = cp.topLeft.y + cp.topLeft.height / 2;
      yl4 = cp.bottomLeft.y + cp.bottomLeft.height / 2 + gap;
      yl5 = bodyLength / 2 + lineWidth / 2;
      if (yl4 > yl5) {
        yl4 = yl5;
      }
      yr1 = -bodyLength / 2 - lineWidth / 2;
      yr2 = cp.topRight.y - cp.topRight.height / 2 - gap;
      if (yr1 > yr2) {
        yr1 = yr2;
      }
      yr3 = cp.bottomRight.y + cp.bottomRight.height / 2 + gap;
      yr4 = bodyLength / 2 + lineWidth / 2;
      if (yr3 > yr4) {
        yl3 = yr4;
      }
      xp = cp.topLeft.x;
      yp = (xp < x2 ? yl2 : yl1) - lineWidth;
      this.preamble(pattern, housing);
      if (housing.polarized) {
        pattern.polarityMark(xp, yp, 'top').moveTo(x1, yl3).lineTo(x1, yl2).lineTo(x2, yl2);
      }
      return pattern.moveTo(x2, yl2).lineTo(x2, yl1).lineTo(x3, yr1).lineTo(x3, yr2).moveTo(x2, yl4).lineTo(x2, yl5).lineTo(x3, yr4).lineTo(x3, yr3);
    },
    gridArray: function(pattern, housing) {
      var bodyLength, bodyWidth, d, dx, dy, len, lineWidth, settings, x, y;
      settings = pattern.settings;
      lineWidth = settings.lineWidth.silkscreen;
      bodyWidth = housing.bodyWidth.nom;
      bodyLength = housing.bodyLength.nom;
      x = bodyWidth / 2 + lineWidth / 2;
      y = bodyLength / 2 + lineWidth / 2;
      dx = x - housing.columnPitch * (housing.columnCount / 2 - 0.5);
      dy = y - housing.rowPitch * (housing.rowCount / 2 - 0.5);
      d = Math.min(dx, dy);
      len = Math.min(2 * housing.columnPitch, 2 * housing.rowPitch, x, y);
      return this.preamble(pattern, housing).moveTo(-x, -y + len).lineTo(-x, -y + d).lineTo(-x + d, -y).lineTo(-x + len, -y).moveTo(x, -y + len).lineTo(x, -y).lineTo(x - len, -y).moveTo(x, y - len).lineTo(x, y).lineTo(x - len, y).moveTo(-x, y - len).lineTo(-x, y).lineTo(-x + len, y).polarityMark(-x, -y, 'center');
    },
    pak: function(pattern, housing) {
      var bodyLength, bodyWidth, firstPad, gap, lastPad, leadSpan, lineWidth, ref, ref1, settings, tabLedge, x1, x2, x3, x4, xp, y0, y1, y2, y3, ym, yp;
      settings = pattern.settings;
      lineWidth = settings.lineWidth.silkscreen;
      bodyWidth = housing.bodyWidth.nom;
      bodyLength = housing.bodyLength.nom;
      leadSpan = housing.leadSpan.nom;
      tabLedge = (ref = housing.tabLedge.nom) != null ? ref : housing.tabLedge;
      ref1 = pattern.extremePads(), firstPad = ref1[0], lastPad = ref1[1];
      gap = lineWidth / 2 + settings.clearance.padToSilk;
      x1 = firstPad.x - firstPad.width / 2 - gap;
      x3 = lastPad.x - lastPad.width / 2 - gap;
      x4 = leadSpan / 2 - tabLedge;
      x2 = x4 - bodyWidth - lineWidth / 2;
      y0 = firstPad.y + firstPad.height / 2;
      y1 = firstPad.y - firstPad.height / 2 - gap;
      y2 = -bodyLength / 2 - lineWidth / 2;
      y3 = lastPad.y - lastPad.height / 2 - gap;
      ym = Math.min(y2, y3);
      xp = firstPad.x;
      yp = y1 - lineWidth;
      return this.preamble(pattern, housing).polarityMark(xp, yp, 'top').moveTo(x1, y0).lineTo(x1, y1).lineTo(x2, y1).lineTo(x2, y2).lineTo(x3, y2).lineTo(x3, ym).lineTo(x4, ym).lineTo(x4, y3).moveTo(x2, -y1).lineTo(x2, -y2).lineTo(x3, -y2).lineTo(x3, -ym).lineTo(x4, -ym).lineTo(x4, -y3);
    },
    preamble: function(pattern, housing) {
      var lineWidth, settings;
      settings = pattern.settings;
      lineWidth = settings.lineWidth.silkscreen;
      pattern.layer('topSilkscreen').lineWidth(lineWidth).attribute('refDes', {
        x: 0,
        y: 0,
        halign: 'center',
        valign: 'center'
      });
      if (housing.silkscreen != null) {
        return pattern.path(housing.silkscreen);
      } else {
        return pattern;
      }
    },
    quad: function(pattern, housing) {
      var bodyLength, bodyWidth, firstPad, gap, lastPad, lineWidth, ref, settings, x1, x2, x3, x4, x5, xp, y1, y2, y3, y4, y5, yp;
      settings = pattern.settings;
      lineWidth = settings.lineWidth.silkscreen;
      bodyWidth = housing.bodyWidth.nom;
      bodyLength = housing.bodyLength.nom;
      ref = pattern.extremePads(), firstPad = ref[0], lastPad = ref[1];
      gap = lineWidth / 2 + settings.clearance.padToSilk;
      x1 = firstPad.x - firstPad.width / 2 - gap;
      x2 = -bodyWidth / 2 - lineWidth / 2;
      x3 = lastPad.x - lastPad.width / 2 - gap;
      if (x1 > x2) {
        x1 = x2;
      }
      if (x2 > x3) {
        x2 = x3;
      }
      x4 = -x3;
      x5 = -x2;
      y1 = -bodyLength / 2 - lineWidth / 2;
      y2 = firstPad.y - firstPad.height / 2 - gap;
      if (y1 > y2) {
        y1 = y2;
      }
      y3 = firstPad.y + firstPad.height / 2;
      y4 = -y2;
      y5 = -y1;
      xp = firstPad.x;
      yp = (xp < x2 ? y2 : y1) - lineWidth;
      return this.preamble(pattern, housing).polarityMark(xp, yp, 'top').moveTo(x1, y3).lineTo(x1, y2).lineTo(x2, y2).lineTo(x2, y1).lineTo(x3, y1).moveTo(x4, y1).lineTo(x5, y1).lineTo(x5, y2).moveTo(x2, y4).lineTo(x2, y5).lineTo(x3, y5).moveTo(x4, y5).lineTo(x5, y5).lineTo(x5, y4);
    },
    twoPin: function(pattern, housing) {
      var bodyLength, bodyWidth, d, firstPad, gap, lastPad, leadWidth, lineWidth, ref, settings, x, x1, x2, y, y2;
      settings = pattern.settings;
      lineWidth = settings.lineWidth.silkscreen;
      bodyWidth = housing.bodyWidth.nom;
      bodyLength = housing.bodyLength.nom;
      leadWidth = housing.leadWidth.nom;
      ref = pattern.extremePads(), firstPad = ref[0], lastPad = ref[1];
      gap = lineWidth / 2 + settings.clearance.padToSilk;
      x1 = firstPad.width / 2 + gap;
      x2 = bodyWidth / 2 + lineWidth / 2;
      x = Math.max(x1, x2);
      y = bodyLength / 2 + lineWidth / 2;
      this.preamble(pattern, housing);
      if (housing.cae) {
        d = x2 - x1;
        pattern.moveTo(-x1, -y).lineTo(-x2, -y + d).lineTo(-x2, y).lineTo(-x1, y).moveTo(x1, -y).lineTo(x2, -y + d).lineTo(x2, y).lineTo(x1, y);
      } else {
        pattern.line(-x, -y, -x, y).line(x, -y, x, y);
        if (x1 < x2) {
          pattern.line(-x1, -y, -x2, -y).line(-x1, y, -x2, y).line(x1, -y, x2, -y).line(x1, y, x2, y);
        }
      }
      if (housing.polarized || housing.cae) {
        y2 = firstPad.y - firstPad.height / 2 - gap;
        return pattern.moveTo(-x1, -y).lineTo(-x1, y2).lineTo(x1, y2).lineTo(x1, -y).polarityMark(0, y2 - lineWidth / 2, 'top');
      }
    }
  };

}).call(this);
