// Generated by CoffeeScript 1.10.0
(function() {
  var assembly, calculator, copper, courtyard, silkscreen, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  module.exports = function(pattern, element) {
    var dx, firstPad, hasTab, housing, leadCount, padParams, settings, width1;
    housing = element.housing;
    housing.polarized = true;
    settings = pattern.settings;
    leadCount = housing.leadCount;
    hasTab = (housing.tabWidth != null) && (housing.tabLength != null);
    if (hasTab) {
      ++leadCount;
    }
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["%sSON%dP%dX%dX%d-%d%s", housing.pullBack != null ? 'P' : ''].concat(slice.call([housing.pitch * 100, housing.bodyLength.nom * 100, housing.bodyWidth.nom * 100, housing.height.max * 100, leadCount].map((function(_this) {
        return function(v) {
          return Math.round(v);
        };
      })(this))), [settings.densityLevel]));
    }
    padParams = calculator.son(pattern, housing);
    padParams.pitch = housing.pitch;
    padParams.count = housing.leadCount;
    padParams.order = 'round';
    padParams.pad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.width,
      height: padParams.height,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    copper.dual(pattern, element, padParams);
    if (padParams.width1 != null) {
      firstPad = pattern.pads[Object.keys(pattern.pads)[0]];
      width1 = padParams.width1;
      dx = width1 - firstPad.width;
      firstPad.x += dx;
      firstPad.width = width1;
    }
    silkscreen.dual(pattern, housing);
    assembly.polarized(pattern, housing);
    courtyard.dual(pattern, housing, padParams.courtyard);
    return copper.tab(pattern, element);
  };

}).call(this);
