// Generated by CoffeeScript 1.10.0
(function() {
  var assembly, calculator, copper, courtyard, silkscreen, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  module.exports = function(pattern, element) {
    var housing, pad1, pad2, padParams, settings;
    housing = element.housing;
    housing.polarized = true;
    settings = pattern.settings;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["SOT%s%dP%dX%d-%d%s%s", housing.flatlead ? 'FL' : ''].concat(slice.call([housing.pitch * 100, housing.leadSpan.nom * 100, housing.height.max * 100, housing.leadCount].map((function(_this) {
        return function(v) {
          return Math.round(v);
        };
      })(this))), [housing.reverse ? 'R' : ''], [settings.densityLevel]));
    }
    padParams = calculator.sot(pattern, housing);
    pad1 = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.width1,
      height: padParams.height1,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    pad2 = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.width2,
      height: padParams.height2,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    if (housing.reversed) {
      pad1.x = -padParams.distance / 2;
      pad1.y = -housing.pitch / 2;
      pattern.pad(1, pad1);
      pad2.x = -padParams.distance / 2;
      pad2.y = housing.pitch / 2 + padParams.height1 / 2 - padParams.height2 / 2;
      pattern.pad(2, pad2);
    } else {
      pad2.x = -padParams.distance / 2;
      pad2.y = -housing.pitch / 2 - padParams.height1 / 2 + padParams.height2 / 2;
      pattern.pad(1, pad2);
      pad1.x = -padParams.distance / 2;
      pad1.y = housing.pitch / 2;
      pattern.pad(2, pad1);
    }
    pad1.x = padParams.distance / 2;
    pad1.y = housing.pitch / 2;
    pattern.pad(3, pad1);
    pad1.y = -housing.pitch / 2;
    pattern.pad(4, pad1);
    copper.mask(pattern);
    silkscreen.dual(pattern, housing);
    assembly.polarized(pattern, housing);
    return courtyard.dual(pattern, housing, padParams.courtyard);
  };

}).call(this);
