// Generated by CoffeeScript 1.10.0
(function() {
  var QedaElement, QedaPattern, QedaSymbol, fs, log, yaml;

  fs = require('fs');

  yaml = require('js-yaml');

  QedaSymbol = require('./qeda-symbol');

  QedaPattern = require('./qeda-pattern');

  log = require('./qeda-log');

  QedaElement = (function() {
    function QedaElement(library, definition) {
      var alias, group, groups, i, j, key, l, last, len, len1, len2, len3, m, name, newAliases, o, option, options, p, part, q, r, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8, suffixes, value;
      this.library = library;
      this.mergeObjects(this, definition);
      if (this.suffix != null) {
        if (this.aliases == null) {
          this.aliases = [];
        }
        newAliases = [];
        suffixes = this.suffix.replace(/\s+/g, '').split(',');
        newAliases = newAliases.concat(suffixes.map((function(_this) {
          return function(v) {
            return _this.name + v;
          };
        })(this)));
        ref = this.aliases;
        for (l = 0, len = ref.length; l < len; l++) {
          alias = ref[l];
          newAliases = newAliases.concat(suffixes.map((function(_this) {
            return function(v) {
              return alias + v;
            };
          })(this)));
        }
        newAliases = newAliases.filter((function(_this) {
          return function(v) {
            return _this.aliases.indexOf(v) === -1;
          };
        })(this));
        this.aliases = this.aliases.concat(newAliases);
      }
      this.longestAlias = this.name;
      if (this.alias != null) {
        ref1 = this.alias;
        for (m = 0, len1 = ref1.length; m < len1; m++) {
          alias = ref1[m];
          if (alias.length > this.longestAlias.length) {
            this.longestAlias = alias;
          }
        }
      }
      this.refDes = 'REF';
      this.symbols = [];
      this.pins = [];
      this.pinGroups = [];
      this.gridLetters = ['', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'R', 'T', 'U', 'V', 'W', 'Y'];
      last = this.gridLetters.length - 1;
      for (i = o = 1, ref2 = last; 1 <= ref2 ? o <= ref2 : o >= ref2; i = 1 <= ref2 ? ++o : --o) {
        for (j = p = ref3 = i, ref4 = last; ref3 <= ref4 ? p <= ref4 : p >= ref4; j = ref3 <= ref4 ? ++p : --p) {
          this.gridLetters.push(this.gridLetters[i] + this.gridLetters[j]);
        }
      }
      this.delimiter = {};
      ref5 = this.joint;
      for (key in ref5) {
        value = ref5[key];
        groups = this.parseMultiple(key);
        for (q = 0, len2 = groups.length; q < len2; q++) {
          group = groups[q];
          this.delimiter[group] = value;
        }
      }
      this._addPins('', this.pinout);
      ref6 = this.groups;
      for (key in ref6) {
        value = ref6[key];
        this.pinGroups[key] = this._concatenateGroups(value);
      }
      if (((ref7 = this.schematic) != null ? ref7.options : void 0) != null) {
        options = this.schematic.options.replace(/\s+/g, '').toLowerCase().split(',');
        for (r = 0, len3 = options.length; r < len3; r++) {
          option = options[r];
          this.schematic[option] = true;
        }
      }
      if (this.parts != null) {
        ref8 = this.parts;
        for (name in ref8) {
          part = ref8[name];
          this.symbols.push(new QedaSymbol(this, this.parseMultiple(part), name));
        }
      } else {
        part = [];
        if (this.groups != null) {
          for (key in this.groups) {
            part.push(key);
          }
        } else {
          for (key in this.pinout) {
            part.push(key);
          }
        }
        this.symbols.push(new QedaSymbol(this, part));
      }
      if (this.housing != null) {
        this.pattern = new QedaPattern(this);
      }
    }

    QedaElement.prototype.cloneSymbol = function(symbol) {
      var newSymbol;
      newSymbol = new QedaSymbol(this, symbol.groups, symbol.name);
      this.symbols.push(newSymbol);
      return newSymbol;
    };

    QedaElement.prototype.isFloat = function(n) {
      return Number(n) && (n % 1 !== 0);
    };

    QedaElement.prototype.mergeObjects = function(dest, src) {
      var k, results, v;
      results = [];
      for (k in src) {
        v = src[k];
        if (typeof v === 'object' && (!Array.isArray(v)) && dest.hasOwnProperty(k)) {
          results.push(this.mergeObjects(dest[k], v));
        } else {
          results.push(dest[k] = v);
        }
      }
      return results;
    };

    QedaElement.prototype.parseMultiple = function(input) {
      var begin, cap, end, group, groups, i, l, len, m, ref, ref1, result;
      if (input == null) {
        return [0];
      }
      result = [];
      groups = input.toString().replace(/\s+/g, '').split(',');
      for (l = 0, len = groups.length; l < len; l++) {
        group = groups[l];
        cap = /(\D*)(\d+)-(\d+)/.exec(group);
        if (cap) {
          begin = parseInt(cap[2]);
          end = parseInt(cap[3]);
          for (i = m = ref = begin, ref1 = end; ref <= ref1 ? m <= ref1 : m >= ref1; i = ref <= ref1 ? ++m : --m) {
            result.push(cap[1] + i);
          }
        } else {
          result.push(group);
        }
      }
      return result;
    };

    QedaElement.prototype.render = function() {
      var cap, dims, dirName, error, error1, fileName, handler, k, l, len, len1, m, option, options, outline, paths, ref, ref1, ref2, ref3, ref4, symbol, v;
      if (this._rendered == null) {
        this._rendered = false;
      }
      if (this._rendered) {
        return;
      }
      if (((ref = this.schematic) != null ? ref.symbol : void 0) != null) {
        paths = ["./symbol/" + (this.library.symbol.style.toLowerCase()) + "/" + (this.schematic.symbol.toLowerCase()), "./symbol/default/" + (this.schematic.symbol.toLowerCase()), process.cwd() + ("/symbol/" + (this.schematic.symbol.toLowerCase()))];
        ref1 = this._firstHandler(paths), handler = ref1[0], error = ref1[1];
        ref2 = this.symbols;
        for (l = 0, len = ref2.length; l < len; l++) {
          symbol = ref2[l];
          log.start("Schematic symbol for '" + this.name + (symbol.name != null ? ': ' + symbol.name : '') + "'");
          if (error) {
            log.exception(error);
          }
          handler(symbol, this);
          log.ok();
        }
      }
      if (this.pattern != null) {
        log.start("Land pattern for '" + this.name + "'");
        if (this.housing.options != null) {
          options = this.housing.options.replace(/\s+/g, '').toLowerCase().split(',');
          for (m = 0, len1 = options.length; m < len1; m++) {
            option = options[m];
            this.housing[option] = true;
          }
        }
        this._convertDimensions(this.housing);
        if (((ref3 = this.housing) != null ? ref3.outline : void 0) != null) {
          cap = this.housing.outline.split(' ');
          dirName = cap.shift().toLowerCase();
          fileName = cap.shift().toLowerCase();
          log.start("Outline '" + this.housing.outline + "'");
          try {
            outline = yaml.safeLoad(fs.readFileSync(__dirname + ("/../share/outline/" + dirName + "/" + fileName + ".yaml")));
          } catch (error1) {
            error = error1;
            log.error(error.message);
          }
          dims = this._processOutline(outline, cap);
          this._convertDimensions(dims);
          for (k in dims) {
            v = dims[k];
            if (this.housing[k] == null) {
              this.housing[k] = v;
            }
          }
          log.ok();
        }
        paths = ["./pattern/" + (this.library.pattern.style.toLowerCase()) + "/" + (this.housing.pattern.toLowerCase()), "./pattern/default/" + (this.housing.pattern.toLowerCase()), process.cwd() + ("/pattern/" + (this.housing.pattern.toLowerCase()))];
        ref4 = this._firstHandler(paths), handler = ref4[0], error = ref4[1];
        if (error) {
          log.exception(error);
        }
        handler(this.pattern, this);
        log.ok();
      }
      return this._rendered = true;
    };

    QedaElement.prototype._addPins = function(name, pinOrGroup) {
      var cap, col, col1, col2, i, key, l, len, len1, m, names, number, numbers, o, p, pinName, pins, q, ref, ref1, ref2, ref3, ref4, result, row, row1, row2, value;
      result = [];
      if (pinOrGroup == null) {
        return result;
      }
      if (typeof pinOrGroup === 'object') {
        for (key in pinOrGroup) {
          value = pinOrGroup[key];
          pinName = this.delimiter[name] != null ? name + this.delimiter[name] + key : key;
          pins = this._addPins(pinName, value);
          this.pinGroups[key] = pins;
          result = result.concat(pins);
        }
      } else {
        if (typeof pinOrGroup === 'number') {
          pinOrGroup = pinOrGroup.toString();
        }
        numbers = pinOrGroup.replace(/\s+/g, '').split(',');
        for (l = 0, len = numbers.length; l < len; l++) {
          number = numbers[l];
          cap = /([A-Z]*)(\d+)-([A-Z]*)(\d+)/.exec(number);
          if (!cap) {
            result.push(number);
          } else {
            row1 = this.gridLetters.indexOf(cap[1]);
            row2 = this.gridLetters.indexOf(cap[3]);
            if (row2 === '') {
              row2 = row1;
            }
            col1 = parseInt(cap[2]);
            col2 = parseInt(cap[4]);
            for (row = m = ref = row1, ref1 = row2; ref <= ref1 ? m <= ref1 : m >= ref1; row = ref <= ref1 ? ++m : --m) {
              for (col = o = ref2 = col1, ref3 = col2; ref2 <= ref3 ? o <= ref3 : o >= ref3; col = ref2 <= ref3 ? ++o : --o) {
                result.push(this.gridLetters[row] + col);
              }
            }
          }
        }
        names = this.parseMultiple(name);
        if (names.length > 1) {
          if (names.length !== result.length) {
            console.error('Error: Pin count does not correspond pad count');
            process.exit(1);
          }
          for (i = p = 0, ref4 = names.length - 1; 0 <= ref4 ? p <= ref4 : p >= ref4; i = 0 <= ref4 ? ++p : --p) {
            this.pins[result[i]] = this._pinObj(result[i], names[i]);
          }
        } else {
          for (q = 0, len1 = result.length; q < len1; q++) {
            number = result[q];
            this.pins[number] = this._pinObj(number, name);
          }
        }
      }
      return result;
    };

    QedaElement.prototype._concatenateGroups = function(groups) {
      var group, l, len, pinGroup, result;
      result = [];
      groups = this.parseMultiple(groups);
      for (l = 0, len = groups.length; l < len; l++) {
        group = groups[l];
        pinGroup = this.pinGroups[group];
        if (pinGroup != null) {
          result = result.concat(pinGroup);
        }
      }
      return result;
    };

    QedaElement.prototype._convertDimensions = function(housing) {
      var dimensions, k, max, min, nom, tol, v;
      dimensions = ['bodyDiameter', 'bodyLength', 'bodyWidth', 'bodyHeight', 'bossDiameter', 'columnSpan', 'height', 'leadDiameter', 'leadHeight', 'leadLength', 'leadSpan', 'leadWidth', 'leadDiameter1', 'leadHeight1', 'leadLength1', 'leadWidth1', 'leadDiameter2', 'leadHeight2', 'leadLength2', 'leadWidth2', 'rowSpan', 'tabWidth', 'tabLength'];
      for (k in housing) {
        v = housing[k];
        if (typeof v === 'string' && (/^\d+(\.\d+)?-\d+(\.\d+)?$/.test(v))) {
          v = v.replace(/\s+/g, '').split('-').map(function(v) {
            return parseFloat(v);
          });
        }
        if (Array.isArray(v) && v.length > 0) {
          min = v[0];
          max = v.length > 1 ? v[1] : min;
          nom = (max + min) / 2;
          tol = max - min;
          housing[k] = {
            min: min,
            max: max,
            nom: nom,
            tol: tol
          };
        } else if (dimensions.indexOf(k) !== -1) {
          min = nom = max = v;
          tol = 0;
          housing[k] = {
            min: min,
            max: max,
            nom: nom,
            tol: tol
          };
        }
      }
      if (housing.units === 'inches') {
        this._inchToMm(housing);
        return delete housing.units;
      }
    };

    QedaElement.prototype._processOutline = function(outline, subkeys, result) {
      var k, re, sk, v, valueType;
      if (result == null) {
        result = {};
      }
      if (outline == null) {
        return result;
      }
      sk = subkeys.shift();
      for (k in outline) {
        v = outline[k];
        valueType = (typeof v === 'number') || (typeof v === 'string');
        if (valueType) {
          if (result[k] == null) {
            result[k] = v;
          }
        } else {
          if (sk == null) {
            return;
          }
          re = new RegExp('^' + k + '$');
          if (re.test(sk)) {
            this._processOutline(outline[k], subkeys, result);
          }
        }
      }
      return result;
    };

    QedaElement.prototype._firstHandler = function(paths) {
      var error, error1, handler, handlerError, handlerPath, l, len;
      for (l = 0, len = paths.length; l < len; l++) {
        handlerPath = paths[l];
        handlerError = null;
        try {
          handler = require(handlerPath);
        } catch (error1) {
          error = error1;
          handlerError = error;
          if (error.code === 'MODULE_NOT_FOUND') {
            continue;
          } else {
            break;
          }
        }
        break;
      }
      return [handler, handlerError];
    };

    QedaElement.prototype._inchToMm = function(value) {
      var k, roundOff, v;
      if (typeof value === 'object') {
        for (k in value) {
          v = value[k];
          value[k] = this._inchToMm(v);
        }
      } else if (this.isFloat(value)) {
        value *= 25.4;
        roundOff = 0.001;
        value = Math.round(value / roundOff) * roundOff;
      }
      return value;
    };

    QedaElement.prototype._pinObj = function(number, name) {
      var l, len, obj, pins, prop, props;
      obj = this.pins[number];
      if (obj != null) {
        if (!this.library.symbol.shortPinNames) {
          obj.name += '/' + name;
        }
      } else {
        obj = {
          name: name,
          number: number
        };
      }
      if (this.properties != null) {
        props = ['analog', 'bidir', 'ground', 'in', 'inverted', 'nc', 'out', 'passive', 'power', 'z'];
        for (l = 0, len = props.length; l < len; l++) {
          prop = props[l];
          if (this.properties[prop] != null) {
            pins = this.parseMultiple(this.properties[prop]);
            if (obj[prop] == null) {
              obj[prop] = false;
            }
            if (pins.indexOf(name) !== -1) {
              obj[prop] = true;
            }
          }
        }
      }
      return obj;
    };

    return QedaElement;

  })();

  module.exports = QedaElement;

}).call(this);
