// Generated by CoffeeScript 1.10.0
(function() {
  var FetIcon, Icon, enclosure,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  enclosure = require('./common/enclosure');

  Icon = require('./common/icon');

  FetIcon = (function(superClass) {
    extend(FetIcon, superClass);

    function FetIcon(symbol, element) {
      var height, width;
      width = 12;
      height = 9;
      this.width = 2 * symbol.alignToGrid(width / 2, 'ceil');
      this.height = 2 * symbol.alignToGrid(height / 2, 'ceil');
      FetIcon.__super__.constructor.call(this, symbol, element);
    }

    FetIcon.prototype.draw = function(x, y) {
      var arrowWidth, gap, i, j, l, space;
      space = 1.5;
      gap = 1;
      arrowWidth = 1.5;
      this.symbol.lineWidth(this.lineWidth).center(x, y).line(-space, -this.height / 2, -space, this.height / 2);
      if (this.schematic.depletion) {
        symbol.line(0, -this.height / 2, 0, this.height / 2);
      } else {
        x = 0;
        y = -this.height / 2;
        l = (this.height - 2 * gap) / 3;
        for (i = j = 1; j <= 3; i = ++j) {
          this.symbol.line(0, y, 0, y + l);
          y += l + gap;
        }
      }
      y = (this.height + gap) / 3;
      this.symbol.line(-this.width / 2, 0, -space, 0).line(0, y, this.width / 2, y).line(this.width / 2, y, this.width / 2, this.height / 2).line(0, -y, this.width / 2, -y).line(this.width / 2, -y, this.width / 2, -this.height / 2);
      if (this.schematic.bulk) {
        this.symbol.line(0, 0, this.width / 4, 0).line(this.width / 4, 0, this.width / 4, y);
      }
      if (this.schematic.n) {
        this.symbol.poly(0, 0, this.width / 8, arrowWidth / 2, this.width / 8, -arrowWidth / 2, 'background');
      }
      if (this.schematic.p) {
        this.symbol.poly(this.width / 8, arrowWidth / 2, this.width / 4, 0, this.width / 8, -arrowWidth / 2, 'background');
      }
      return this.symbol.center(0, 0);
    };

    return FetIcon;

  })(Icon);

  module.exports = function(symbol, element) {
    var d, drain, g, gate, height, icon, j, k, len, len1, len2, m, n, needEnclosure, pin, pinGroups, pinLength, pins, r, ref, s, schematic, settings, source, step, v, valid, width, x, y;
    element.refDes = 'VT';
    schematic = element.schematic;
    settings = symbol.settings;
    pins = element.pins;
    pinGroups = element.pinGroups;
    schematic.showPinNumbers = true;
    icon = new FetIcon(symbol, element);
    for (k in pinGroups) {
      v = pinGroups[k];
      switch (k) {
        case 'G':
          gate = v;
          break;
        case 'D':
          drain = v;
          break;
        case 'S':
          source = v;
          break;
        default:
          needEnclosure = true;
      }
    }
    valid = (gate != null) && (drain != null) && (source != null);
    if ((!valid) || needEnclosure) {
      schematic.showPinNames = true;
      return enclosure(symbol, element, icon);
    } else {
      width = icon.width;
      height = icon.height;
      pinLength = symbol.alignToGrid((ref = settings.pinLength) != null ? ref : 10);
      step = symbol.alignToGrid(5);
      r = width / 2;
      symbol.attribute('refDes', {
        x: width / 2 - settings.fontSize.pin - settings.space.attribute,
        y: -r - settings.space.attribute,
        halign: 'right',
        valign: 'bottom'
      }).attribute('name', {
        x: width / 2 - settings.fontSize.pin - settings.space.attribute,
        y: r + settings.space.attribute,
        halign: 'right',
        valign: 'top'
      }).lineWidth(settings.lineWidth.thick).circle(0, 0, r, settings.fill);
      icon.draw(0, 0);
      y = 0;
      for (j = 0, len = gate.length; j < len; j++) {
        g = gate[j];
        pin = pins[g];
        pin.x = -width / 2 - pinLength;
        pin.y = y;
        pin.length = pinLength;
        pin.orientation = 'right';
        symbol.pin(pin);
        y += step;
      }
      symbol.line(-width / 2, 0, -width / 2, (gate.length - 1) * step);
      x = width / 2;
      for (m = 0, len1 = drain.length; m < len1; m++) {
        d = drain[m];
        pin = pins[d];
        pin.x = x;
        pin.y = -height / 2 - pinLength;
        pin.length = pinLength;
        pin.orientation = 'down';
        symbol.pin(pin);
        x += step;
      }
      symbol.line(width / 2, -height / 2, width / 2 + (drain.length - 1) * step, -height / 2);
      x = width / 2;
      for (n = 0, len2 = source.length; n < len2; n++) {
        s = source[n];
        pin = pins[s];
        pin.x = x;
        pin.y = height / 2 + pinLength;
        pin.length = pinLength;
        pin.orientation = 'up';
        symbol.pin(pin);
        x += step;
      }
      return symbol.line(width / 2, height / 2, width / 2 + (source.length - 1) * step, height / 2);
    }
  };

}).call(this);
